@import "variables";
@import "libs/normalize.css/normalize";

// Animations (by https://animate.style/)
@keyframes euccZoomIn {
  from {
    opacity: 0;
    transform: scale3d(0.3, 0.3, 0.3);
  }

  50% {
    opacity: 1;
  }
}
@keyframes euccZoomOut {
  from {
    opacity: 1;
  }

  50% {
    opacity: 0;
    transform: scale3d(0.3, 0.3, 0.3);
  }

  to {
    opacity: 0;
  }
}

.eucc {
  // General
  --eucc-bg: white;
  --eucc-text: #555;
  --eucc-shadow: 0 0 8px rgba(0, 0, 0, 0.35);
  --eucc-padding: 25px;
  --eucc-radius: 8px;
  --eucc-max-width: 960px;
  --eucc-space-bottom: 15px;
  // Colors
  --eucc-black: #222;
  --eucc-grey: #666;
  --eucc-success: #96bc44;
  --eucc-error: #bc4444;
  // Typo
  --eucc-font-size: 16px;
  --eucc-font-weight-bold: bold;
  // Spacings
  --eucc-grid-gutter: 25px;
  --eucc-grid-gutter-half: calc(var(--eucc-grid-gutter) / 2);
  // Buttons
  --eucc-button-font-size: var(--eucc-font-size);
  --eucc-button-radius: 3px;
  --eucc-button-padding: 0.5em 1em;
  --eucc-button-default-bg: var(--eucc-grey);
  --eucc-button-default-text: white;
  --eucc-button-cta-bg: #96bc44;
  --eucc-button-cta-text: white;
  // Icons
  --eucc-icon-size: 16px;
  // Checkboxes
  --eucc-checkbox-size: 16px;
  --eucc-checkbox-border-width: 1px;
  // Misc
  --eucc-toggle-bg: #222;
  --eucc-toggle-text: white;
  --eucc-link-color: currentColor;
  --eucc-link-color-hover: #0678be;

  box-sizing: border-box;
  font-size: var(--eucc-font-size);
  position: fixed;
  left: 50%;
  bottom: var(--eucc-space-bottom);
  width: 90%;
  max-width: var(--eucc-max-width);
  padding: var(--eucc-padding);
  border-radius: var(--eucc-radius);
  background-color: var(--eucc-bg);
  color: var(--eucc-text);
  box-shadow: var(--eucc-shadow);
  // default hidden
  transition-duration: 150ms;
  transition-property: transform, opacity;
  transform: translateY(calc(100% + var(--eucc-space-bottom))) translateX(-50%);
  * {
    box-sizing: inherit;
  }
  &__inner {
    display: flex;
    flex-flow: row wrap;
    pointer-events: none;
    margin: calc(var(--eucc-grid-gutter-half) * -1);
    > * {
      padding: var(--eucc-grid-gutter-half) !important;
    }
  }
  &__toggle {
    // "Withdraw"-Tab
    display: flex;
    align-items: center;
    position: absolute;
    top: 0;
    left: 50%;
    transform: translate(-50%, -100%);
    background: var(--eucc-toggle-bg);
    color: var(--eucc-toggle-text);
    padding: 0.65em 1em;
    font-weight: var(--eucc-font-weight-bold);
    border-radius: var(--eucc-radius) var(--eucc-radius) 0 0;
    cursor: pointer;
    line-height: 1;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
    transition-duration: 150ms;
    transition-property: padding;
    &:hover {
      padding-top: 0.75em;
      padding-bottom: 0.75em;
    }
  }
  &__message {
    flex: 1 1 45%;
    min-width: 300px;
    line-height: 1.25;
    strong{
      color: var(--eucc-black);
    }
    p {
      margin: 0 0 0.5em;
      &:last-child {
        margin-bottom: 0;
      }
    }
    a {
      color: var(--eucc-link-color);
      &:hover {
        color: var(--eucc-link-color-hover);
      }
    }
  }
  &__categories {
    flex: 0 1 auto;
    list-style: none;
    margin: 0;
    padding: 0;
  }
  &__category {
    display: flex;
    align-items: center;
  }
  &__buttons {
    flex: 1 1 auto;
    > *:not(:last-child) {
      margin-bottom: 0.25em;
    }
  }
  &--visible {
    transform: translateY(0) translateX(-50%);
    .eucc__inner{
      pointer-events: all;
    }
  }
}

.eucc-button {
  display: block;
  cursor: pointer;
  border: 1px solid var(--eucc-button-default-bg);
  background: var(--eucc-button-default-bg);
  color: var(--eucc-button-default-text);
  padding: var(--eucc-button-padding);
  border-radius: var(--eucc-button-radius);
  width: 100%;
  font-size: var(--eucc-button-font-size);
  line-height: 1.1;
  transition-duration: 150ms;
  transition-property: background-color, border-color, filter;
  &:hover {
    filter: brightness(105%);
  }
  &:focus {
    // TODO
    outline: 2px solid var(--eucc-link-color-hover);
  }
  &--cta {
    font-weight: var(--eucc-font-weight-bold);
    border-color: var(--eucc-button-cta-bg);
    background: var(--eucc-button-cta-bg);
    color: var(--eucc-button-cta-text);
  }
  &--hollow {
    &:not(:hover) {
      background: none;
      color: var(--eucc-text);
    }
  }
  &--accept-all {
    padding-top: 0.75em;
    padding-bottom: 0.75em;
  }
}

.eucc-icon {
  display: inline-flex;
  align-items: center;
  justify-content: center;
  width: var(--eucc-icon-size);
  height: var(--eucc-icon-size);
  line-height: 1;
  &:not(:only-child) {
    margin-right: .35em;
  }
  svg {
    flex: 0 0 100%;
    width: 100%;
    height: 100%;
    max-width: 100%;
    path {
      fill: currentColor;
    }
  }
}

.eucc-checkbox-label {
  position: relative;
  > input[type="checkbox"] {
    display: none;
    &:checked {
      + label {
        &::before {
          border-color: var(--eucc-success);
        }
        .eucc-checkbox-label__check-icon {
          animation-name: euccZoomIn;
        }
      }
    }
    &:not(:checked) {
      + label .eucc-checkbox-label__check-icon {
        animation-name: euccZoomOut;
      }
    }
    &:disabled {
      + label {
        opacity: 0.75;
        cursor: not-allowed;
      }
    }
  }
  &__check-icon {
    position: relative;
    margin-left: calc(var(--eucc-checkbox-size) * -1);
    animation-duration: 150ms;
    animation-fill-mode: both;
    width: var(--eucc-checkbox-size);
    height: var(--eucc-checkbox-size);
    svg path {
      fill: var(--eucc-success);
    }
  }
  > label {
    display: flex;
    align-items: center;
    user-select: none;
    cursor: pointer;
    &::before {
      content: "";
      display: block;
      border: var(--eucc-checkbox-border-width) solid var(--eucc-grey);
      width: 1em;
      height: 1em;
    }
  }
  &:hover {
    > label::before {
      border-color: var(--eucc-success);
    }
  }
}
